﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using System.Windows.Data;

namespace TileViewWithFluidContentControl
{
	public partial class MainPage : UserControl
	{
		private ObservableCollection<TileViewModel> items = new ObservableCollection<TileViewModel>();

		public MainPage()
		{
			InitializeComponent();

			items.Add(new TileViewModel() { Header = "One", SmallContent = "SMALL", NormalContent = "NORMAL", LargeContent = "LARGE" });
			items.Add(new TileViewModel() { Header = "Two", SmallContent = "SMALL", NormalContent = "NORMAL", LargeContent = "LARGE" });
			items.Add(new TileViewModel() { Header = "Three", SmallContent = "SMALL", NormalContent = "NORMAL", LargeContent = "LARGE" });
			items.Add(new TileViewModel() { Header = "Four", SmallContent = "SMALL", NormalContent = "NORMAL", LargeContent = "LARGE" });

			this.myTileView.ItemsSource = items;
		}

		private void myTileView_Loaded(object sender, RoutedEventArgs e)
		{
			this.Dispatcher.BeginInvoke(new Action(() =>
			{
				foreach (TileViewModel item in myTileView.Items)
				{
					Binding binding = new Binding
					{
						Path = new PropertyPath("TileState"),
						Mode = BindingMode.TwoWay,
						Source = (this.myTileView.ItemContainerGenerator.ContainerFromItem(item) as RadTileViewItem),
						Converter = new FluidContentStateConverter()
					};

					(this.myTileView.ItemContainerGenerator.ContainerFromItem(item) as RadTileViewItem).
						ChildrenOfType<RadFluidContentControl>().FirstOrDefault().
						SetBinding(RadFluidContentControl.StateProperty, binding);
				}
			}));
		}

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            (this.myTileView.Items[0] as TileViewModel).SmallContent = " NA BABA TI HVYRCHILOTO";
            this.myTileView.ChildrenOfType<RadFluidContentControl>()[0].ChildrenOfType<TextBlock>()[0].Foreground = new SolidColorBrush() { Color = Colors.Blue };
            this.myTileView.ChildrenOfType<RadFluidContentControl>()[0].ChildrenOfType<TextBlock>()[0].FontWeight = FontWeights.Bold;
        }
	}
}
